# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventHub::Mgmt::V2014_09_01
  module Models
    #
    # Single item in a List or Get AuthorizationRule operation
    #
    class SharedAccessAuthorizationRulePostResource < Resource

      include MsRestAzure

      # @return [Array<AccessRights>] The rights associated with the rule.
      attr_accessor :rights

      # @return [String] A base64-encoded 256-bit primary key for signing and
      # validating the SAS token.
      attr_accessor :primary_key

      # @return [String] A base64-encoded 256-bit primary key for signing and
      # validating the SAS token.
      attr_accessor :secondary_key

      # @return [String] A string that describes the Key Name of authorization
      # rule.
      attr_accessor :key_name

      # @return [String] A string that describes Claim Type for authorization
      # rule.
      attr_accessor :claim_type

      # @return [String] A string that describes Claim Value of authorization
      # rule.
      attr_accessor :claim_value

      # @return [DateTime] The time the namespace was created.
      attr_accessor :created_time

      # @return [DateTime] The time the namespace was updated.
      attr_accessor :modified_time


      #
      # Mapper for SharedAccessAuthorizationRulePostResource class as Ruby
      # Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SharedAccessAuthorizationRulePostResource',
          type: {
            name: 'Composite',
            class_name: 'SharedAccessAuthorizationRulePostResource',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              rights: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.rights',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'AccessRightsElementType',
                      type: {
                        name: 'Enum',
                        module: 'AccessRights'
                      }
                  }
                }
              },
              primary_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.primaryKey',
                type: {
                  name: 'String'
                }
              },
              secondary_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.secondaryKey',
                type: {
                  name: 'String'
                }
              },
              key_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.keyName',
                type: {
                  name: 'String'
                }
              },
              claim_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.claimType',
                type: {
                  name: 'String'
                }
              },
              claim_value: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.claimValue',
                type: {
                  name: 'String'
                }
              },
              created_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdTime',
                type: {
                  name: 'DateTime'
                }
              },
              modified_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.modifiedTime',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
